# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/blueprint/datatypes/time_range_query.fbs".

# You can extend this class by creating a "TimeRangeQueryExt" class in "time_range_query_ext.py".

from __future__ import annotations

from typing import Any, Sequence, Union

import pyarrow as pa
from attrs import define, field

from ... import datatypes
from ..._baseclasses import (
    BaseBatch,
    BaseExtensionType,
)
from .time_range_query_ext import TimeRangeQueryExt

__all__ = [
    "TimeRangeQuery",
    "TimeRangeQueryArrayLike",
    "TimeRangeQueryBatch",
    "TimeRangeQueryLike",
    "TimeRangeQueryType",
]


def _time_range_query__timeline__special_field_converter_override(x: datatypes.Utf8Like) -> datatypes.Utf8:
    if isinstance(x, datatypes.Utf8):
        return x
    else:
        return datatypes.Utf8(x)


@define(init=False)
class TimeRangeQuery(TimeRangeQueryExt):
    """**Datatype**: Time range query configuration for a specific timeline."""

    def __init__(self: Any, timeline: datatypes.Utf8Like, start: datatypes.TimeIntLike, end: datatypes.TimeIntLike):
        """
        Create a new instance of the TimeRangeQuery datatype.

        Parameters
        ----------
        timeline:
            Name of the timeline this applies to.
        start:
            Beginning of the time range.
        end:
            End of the time range (inclusive).

        """

        # You can define your own __init__ function as a member of TimeRangeQueryExt in time_range_query_ext.py
        self.__attrs_init__(timeline=timeline, start=start, end=end)

    timeline: datatypes.Utf8 = field(converter=_time_range_query__timeline__special_field_converter_override)
    # Name of the timeline this applies to.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    start: datatypes.TimeInt = field(
        converter=TimeRangeQueryExt.start__field_converter_override,  # type: ignore[misc]
    )
    # Beginning of the time range.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    end: datatypes.TimeInt = field(
        converter=TimeRangeQueryExt.end__field_converter_override,  # type: ignore[misc]
    )
    # End of the time range (inclusive).
    #
    # (Docstring intentionally commented out to hide this field from the docs)


TimeRangeQueryLike = TimeRangeQuery
TimeRangeQueryArrayLike = Union[
    TimeRangeQuery,
    Sequence[TimeRangeQueryLike],
]


class TimeRangeQueryType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.blueprint.datatypes.TimeRangeQuery"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(
            self,
            pa.struct([
                pa.field("timeline", pa.utf8(), nullable=False, metadata={}),
                pa.field("start", pa.int64(), nullable=False, metadata={}),
                pa.field("end", pa.int64(), nullable=False, metadata={}),
            ]),
            self._TYPE_NAME,
        )


class TimeRangeQueryBatch(BaseBatch[TimeRangeQueryArrayLike]):
    _ARROW_TYPE = TimeRangeQueryType()

    @staticmethod
    def _native_to_pa_array(data: TimeRangeQueryArrayLike, data_type: pa.DataType) -> pa.Array:
        from rerun.datatypes import TimeIntBatch, Utf8Batch

        if isinstance(data, TimeRangeQuery):
            data = [data]

        return pa.StructArray.from_arrays(
            [
                Utf8Batch([x.timeline for x in data]).as_arrow_array().storage,  # type: ignore[misc, arg-type]
                TimeIntBatch([x.start for x in data]).as_arrow_array().storage,  # type: ignore[misc, arg-type]
                TimeIntBatch([x.end for x in data]).as_arrow_array().storage,  # type: ignore[misc, arg-type]
            ],
            fields=list(data_type),
        )
